<?php

function print_globals() {

	if (isset($GLOBALS['HTTP_GET_VARS'])){
		while(list($k,$v)=each($GLOBALS['HTTP_GET_VARS'])){printf("%-16s= %s<br>\n",$k,$v);}}
	if (isset($GLOBALS['HTTP_POST_VARS'])){
		while(list($k,$v)=each($GLOBALS['HTTP_POST_VARS'])){printf("%-16s= %s<br>\n",$k,$v);}}
	if (isset($GLOBALS['HTTP_COOKIE_VARS'])){
		while(list($k,$v)=each($GLOBALS['HTTP_COOKIE_VARS'])){printf("%-16s= %s<br>\n",$k,$v);}}
}

#---- misc support sub-routines -------------------------------

function getdatetime()
{
	$datemonths = array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	$today  = date("D M j H:i:s Y");
        $nummon = 0;
	list($day,$mon,$dayofmon,$time,$year) = split(" ",$today);

	while(list($k,$mons)=each($datemonths))
	{
		if (strcmp($mon,$mons))
		{
			$nummon++;
		}
	}
	$nummon++;
	return "$year-$nummon-$dayofmon $time";
}

function formatseconds($seconds)
{
	$hours = 0;
	$minutes = 0;
	$ret = '';

	while ($seconds >= 3600)
        {
		$seconds -= 3600;
		$hours += 1;
	}

	while ($seconds >= 60)
        {
		$seconds -= 60;
		$minutes += 1;
	}
	if ($hours != 0) { $ret = "$hours"."h:"; }

	$ret .= "$minutes"."m:".$seconds."s";

	return $ret;
}

function error($error,$arg1="")
{
	global $body;
        
	printheader();

	if (strcmp($error,'not_admin'))
	{
		print "<html><head><title>Error!</title></head>\n";
		print "$body\n";
		print "<center><h1><font face=arial>Error!</font></h1></center>\n";
		print "<font face=arial>Unauthorized attempt to access ICRADIUS administration.</font>\n";
		print "<br><font face=arial>Please login again if you think this is an error.</font>\n";
		print "<form><input type=button value=\"<<Back\" OnClick=\"history.back()\"></form>\n";
		print "</body></html>\n";
	}
	 else if (strcmp($error,'expired'))
	{
		print "<html><head><title>Error!</title></head>\n";
		print "$body\n";
		print "<center><h1><font face=arial>Error!</font></h1></center>\n";
		print "<font face=arial>Your session has timed out for security reasons.</font>\n";
		print "<br><font face=arial>Please login again <a href=\"$PHP_SELF\" target=\"_top\">HERE</a>\n";
		print "</font></body></html>\n";
	}
	 else if (strcmp($error,'exists'))
	{
		print "<html><head><title>Error!</title></head>\n";
		print "$body\n";
		print "<center><h1><font face=arial>Error!</font></h1></center>\n";
		print "<font face=arial>The user you are trying to enter already exists. Please go back and enter a different username</font>\n";
		print "</font></body></html>\n";
	}
	 else if (strcmp($error,'ingroup'))
	{
		print "<html><head><title>Error!</title></head>\n";
		print "$body\n";
		print "<center><h1><font face=arial>Error!</font></h1></center>\n";
		print "<font face=arial>This user is already in the group <i>$arg1</i>. Please go back and deselect group <i>$arg1</i> from the list.</font>\n";
		print "<form><input type=button value=\"<<Back\" OnClick=\"history.back()\"></form>\n";
		print "</font></body></html>\n";
	}
	 else if (strcmp($error,'sess_expired'))
	{
		print "<html>$body\n";
		print "<center><font size=4>Your session has expired.</font></center>\n";
		print "<br><br><center>Please login again <a href=\"$PHP_SELF?action=login\" target=\"_top\"> HERE</a></center>\n";
		print "</body></html>\n";
	}
	exit;
}


# Returns the day of the month

function getdayofmon()
{
	return date("j");
}

function newarry($avg,$used) {

	$stuff[0] = parsefloat($avg, 2);
	$stuff[1] = split("\.", $avg * $DAYSPERMON);
	$stuff[2] = split("\.",$used);
	return $stuff;
}

# return number plus n decimal places

function parsefloat($float,$places) {

	list($printfloat, $junk) = split("\.", $float);
	$dec = substr($junk, 0, $places);
	$printfloat .= ".$dec";
	return $printfloat;
}

#print a html header if not printed yet

function printheader() {

$printheader = 1; # I really want to get rid of this toggle --markc

	if ($printheader)
	{
		print "Content-Type: text/html\n\n";
		$printheader = 0;
while(list($k,$v)=each($GLOBALS)){error_log(sprintf("%-16s= %s\n",$k,$v));}
	}
}

#verify user can access administration

function checksession() {

	global $username,$sessionid;

	if (strcmp($sessionid,''))
	{
		printheader();
		if (!$sessionid)
		{
			error('sess_expired');
		} else {
			printlogin();
			exit;
		}
	}

	open(SESSFILE, "$sessiondir/$sessionid") || error('sess_expired');
	list($a,$b,$c,$d,$e,$f,$g,$atime) = stat("$sessiondir/$sessionid");
print "$a,$b,$c,$d,$e,$f,$g,$atime\n";
#  chomp($sessuser = <SESSFILE>);
	close(SESSFILE);
	error('sess_expired if $sessuser ne $username');

	$now = time();
	if ($now - $sessexpire > $atime)
	{
		unlink($sessiondir/$sessionid);
		error('sess_expired');
	}

	setcookie('username',$username,$cookieexpire,$cookiedomain);
	setcookie('sessionid',$sessionid,$cookieexpire,$cookiedomain);
  
	$printheader = 0;
	return 0;
}

# checks the username and pass against the database

function checkuserpass($username,$password) {

	if ($authtype == 0)
        {
		$sth = mysql_query("SELECT id FROM radcheck WHERE UserName = \"$username\" AND Attribute = \"Radius-Operator\"");
		$check = mysql_fetch_row($sth);
		if (!$check)
		{
			return 0;
		}
   
		$sth = mysql_query("SELECT id FROM radcheck WHERE UserName = \"$username\" AND Attribute = \"Password\" AND Value = \"$password\"");
		$check = mysql_fetch_row($sth);
		if (!$check)
		{
			return 0;
		}
	} else if ($authtype == 1) {

#     $r = new Authen::Radius(Host => $radhost, Secret => $radsecret);
#     $authed = $r->check_pwd($username, $password);
#     return 0 if !$authed;
#     $authed = 0;
#     @attribs = $r->get_attributes;
#	for $attr (@attribs) {
#	 # attrib number 100 is Radius-Operator
#         if ($attr->{'Name'} eq '100') {
#           $authed = unpack('N', $attr->{'RawValue'});
#         }
#     }
#     return 0 if !$authed;

	}
	return 1;
}

?>
