<?php
/*
 phpicradius v0.1.3 (31 March 2000)

 Initial conversion to PHP finished on Tue Dec 14 01:33:04 +1000 1999
 by Mark Constable <markc@renta.net> with encouragment by Cam Proctor
 
 Modified by Thomas St.Pierre on March 3 2000
 Finally uploaded to SourceForge on 31 March 2000

 These first 7 variables should be in a site specific included file
 called /etc/phpicradius.conf (change to wherever you like) so we can
 upgrade the package and not have to edit anything.

------------< Start conf.inc >------------------------------------------
<?php
$cookiedomain	= '';	# domain if THIS server, should prepend with a '.'
$dbhost		= '';	# host radius database is on
$dbname		= '';	# the icradius database name
$dbpassword	= '';	# password to access radius database
$dbusername	= '';	# username to access radius database
$radhost	= '';	# RADIUS host
$radsecret	= '';	# RADIUS secret to connect to $radhost
?>
------------< End conf.inc    >-----------------------------------------
*/

require '/etc/phpicradius.conf';
require 'misc.inc';
require 'html.inc';

$DAYSPERMON	= 30;
$authtype	= 1;			# 0 = local lookup; 1 = RADIUS authentication
$body		= "<body bgcolor=\"#ffffff\">";
$cookieexpire	= '+12h';		# expire the cookie session after this much idle time
$i		= 0;
$logfile	= "/var/log/radius.log";# file of radius log (if on this server). Used to view log via web
$printheader	= 1;
$printmainpage	= 1;
$sessexpire	= 43200;		# expire session after this long of no use (in seconds)
$sessiondir	= './radsess';		# directory to place session information
$total		= 0;

$open		= mysql_connect($dbhost, $dbusername, $dbpassword);
$dbh		= @mysql_select_db($dbname, $open);
$now		= getdatetime();

# The following 3 are to prevent warnings only --markc
if (!isset($action)) $action = '';
if (!isset($GLOBALS['HTTP_GET_VARS'])) $GLOBALS['HTTP_GET_VARS'] = array();
if (!isset($GLOBALS['HTTP_POST_VARS'])) $GLOBALS['HTTP_POST_VARS'] = array();

#---- first executable code switch ----------------------------------------------

# if they are trying to login we wont check the session yet

if (isset($login) && !strcmp($action,'login'))
{
	checksession();
	printheader();
}
 else if (!$GLOBALS['HTTP_GET_VARS'] && !$GLOBALS['HTTP_POST_VARS'])
{
	printmainpage();
        exit(0);
}

#---- second executable code switch ----------------------------------------------

if (isset($removeuserchecks)) {

	while(list($k,$argv)=each($argvid))
	{
		$sth	= mysql_query("DELETE FROM radcheck WHERE id = '$argv'");
	}

	$action		= 'userargvlist';

} else if (isset($removeuserreply)) {

	while(list($k,$argv)=each($argvid))
	{
		$sth	= mysql_query("DELETE FROM radreply WHERE id = '$argv'");
	}

	$action		= 'userargvlist';

} else if (isset($removegroupchecks)) {

	while(list($k,$argv)=each($argvid))
	{
		$sth = mysql_query("DELETE FROM radgroupcheck WHERE id = '$argv'");
	}

	$action		= 'groupargvlist';
	
} else if (isset($removegroupreply)) {

	while(list($k,$argv)=each($argvid))
	{
		$sth	= mysql_query("DELETE FROM radgroupreply WHERE id = '$argv'");
	}

	$action		= 'groupargvlist';
	
} else if (isset($removeusergroup)) {

	while(list($k,$argv)=each($usergroupid))
	{
		$sth	= mysql_query("DELETE FROM usergroup WHERE id = '$argv'");
	}

	$action 	= 'userargvlist';

} else if (isset($doaddusercheck)) {
   
#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("INSERT INTO radcheck VALUES ('','$username','$attribute','$value')");

} else if (isset($doeditusercheck)) {

#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("UPDATE radcheck SET Attribute = '$attribute', Value = '$value' WHERE id = '$userid'");

} else if (isset($doeditnas)) {

#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("UPDATE nas SET nasname = '$nasname', shortname = '$shortame', ipaddr = '$ipaddr', type = '$type', ports = '$ports', secret = '$secret', community = '$community', snmp = '$snmp' WHERE id = '$nasid'");
	echo "Saved...";
} else if (isset($doadduserreply)) {

#$quoted		= $dbh->quote($value);
	$sth		= mysql_query("INSERT INTO radreply VALUES ('','$username','$attribute','$value')");

} else if (isset($doedituserreply)) {

#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("UPDATE radreply SET Attribute = '$attribute', Value = '$value' WHERE id = '$replyid'");

} else if (isset($doaddgroupcheck)) {

#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("INSERT INTO radgroupcheck VALUES ('','$groupname','$attribute','$value')");
#	$sth		= mysql_query("SELECT LAST_INSERT_ID()");
#	$id		= mysql_fetch_row($sth);
#	$groupid	= $id;

} else if (isset($doeditgroupcheck)) {

#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("UPDATE radgroupcheck SET Attribute = '$attribute', Value = '$value' WHERE id = '$id'");

} else if (isset($doaddgroupreply)) {

#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("INSERT INTO radgroupreply VALUES ('','$groupname','$attribute','$value')");
#	$sth		= mysql_query("SELECT LAST_INSERT_ID()");
#	$id		= mysql_fetch_row($sth);
#	$groupid	= $id;

} else if (isset($doeditgroupreply)) {

#	$quoted		= $dbh->quote($value);
	$sth		= mysql_query("UPDATE radgroupreply SET Attribute = '$attribute', Value = '$value' WHERE id = '$id'");

} else if (isset($doadduser)) {

	$sth		= mysql_query("SELECT id FROM radcheck WHERE UserName = '$username'");
	$check		= mysql_fetch_row($sth);
	if (!$check) error('$check does not exist');
	$sth		= mysql_query("INSERT INTO radcheck VALUES ('','$username','Password','$password')");
	$sth		= mysql_query("SELECT LAST_INSERT_ID()");
	$userid		= mysql_fetch_row($sth);
	$action		= 'edituser';

} else if (isset($doaddtogroup)) {

	while(list($k,$group)=each($groups))
	{
		$sth	= mysql_query("SELECT id FROM usergroup WHERE UserName = '$username' AND GroupName = '$group'");
		$check	= mysql_fetch_row($sth);
		if ($check) error('ingroup', $group);
#	}
#
#	while(list($k,$group)=each($groups))
#	{
		$sth	= mysql_query("INSERT INTO usergroup VALUES ('','$username','$group')");
	}
	doaddtogroup($PHP_SELF,$userid);
	exit();

} else if (isset($removenas)) {

	$sth		= mysql_query("DELETE FROM nas WHERE id = '$nasid'");

	echo "<html>$body\n";
	echo "<center><h2>User $nasname Has Been Deleted</h2>\n";
	echo "</body></html>\n";
	$action = "managenas";

} else if (isset($dodeluser)) {

	$sth		= mysql_query("DELETE FROM radcheck WHERE UserName = '$username'");
	$sth		= mysql_query("DELETE FROM radreply WHERE UserName = '$username'");
	$sth		= mysql_query("DELETE FROM usergroup WHERE UserName = '$username'");

	echo "<html>$body\n";
	echo "<center><h2>User $username Has Been Deleted</h2>\n";
	echo "</body></html>\n";

} else if (isset($dodelgroup)) {

	$sth		= mysql_query("DELETE FROM radgroupcheck WHERE GroupName = '$groupname'");
	$sth		= mysql_query("DELETE FROM radgroupreply WHERE GroupName = '$groupname'");
	$sth		= mysql_query("DELETE FROM UserGroup WHERE GroupName = '$groupname'");

	echo "<html>$body\n";
	echo "<center><h2>Group $groupname Has Been Deleted</h2>\n";
	echo "</body></html>\n";
}

#---- third executable code switch ----------------------------------------------

if	($action == 'summary')		{ summary();		}
else if ($action == 'utilization')	{ utilization();	}
else if (isset($login)) {

	if (!checkuserpass($username, $password))
	{
		printheader();
		error('not_admin');
	}

	$alpha		= array(); # help! (alphanumerics only) --markc
	$notunique	= 1;
	srand((double)microtime()*1000000);

	while ($notunique)
	{
		$sessid = '';

		for ($i = 0; $i < 10; $i++)
                {
			$sessid .= string(rand(30,60));
error_log("sessid = $sessid");
		}
		$notunique = 0;
		if (stat("$sessiondir/$sessid")) { $notunique = 1; }
	}

	setcookie('username',$username,$cookieexpire,$cookiedomain);
	setcookie('sessionid',$sessid,$cookieexpire,$cookiedomain);

	$fp = fopen("$sessiondir/$sessid",w)
        	|| error("Could not open $sessiondir/$sessid for writing $!\n");
	fwrite($fp,"$username\n");
	fclose($fp);
	printmainpage();

} else if (isset($doviewlog)) {

	$str1 = $str2 = '';
	if (isset($doviewlog_scroll))
	{
		$str1 = "
    <script language=\"JavaScript\">

// toggle scrolling mode
function toggleScroll() {

	if (scrolltimeron) {
		stopScroll();
	} else {
		scrollit(8);
	}
}

timerShow = null;
scrolltimer = null;
scrolltimeron = false;

function stopScroll() {

	if (scrolltimeron) {
		clearTimeout(scrolltimer);
	}
	scrolltimeron = false;
}

function scrollit(speed) {

	s = speed;
	top.window.rightmainframe.scrollBy(0,s);
	scrolltimer = setTimeout(scrollit(s),'50');
	scrolltimeron = true;
}
toggleScroll();

    </script>";
	}

	if (isset($doviewlog_scroll))
	{
		$str2 .= "<body bgcolor=\"#ffffff\" OnLoad=\"window.rightmainframe.scrollBy(0,8)\">\n";
	}
	$str2 .= "<pre>\n";

# help! this won't work --markc
	if (isset($doviewlog_scroll))
	{
		exec("/usr/bin/tail -f $logfile");
	} else {
		system("/usr/bin/tail -$lines $logfile");
	}

	doviewlog($PHP_SELF,$body,$lines,$str1,$str2);
}
else if (isset($blankframe))		{ blankframe();			}
else if ($action == 'blankframe')	{ blankframe();			}
else if ($action == 'navframe')		{ navframe();			}
else if ($action == 'rightmainframe')	{ rightmainframe();		}
else if ($action == 'manageusers')	{ manageusers();		}
else if ($action == 'manageusersearch')	{ manageusersearch();		}
else if (isset($finduser))		{

	$str		= '';
	$sth		= mysql_query("SELECT DISTINCT UserName AS U, id FROM radcheck WHERE UserName LIKE '$user%' GROUP BY U");

	while ($users	= mysql_fetch_row($sth))
        {
		$str   .= "<tr align=center><td><a href=\"$PHP_SELF?userid=$users[1]&action=edituser\" target=\"rightmainframe\">$users[0]</a></td></tr>\n";
	}

	finduser($body,$str);
}
else if ($action == 'managegroups')	{ managegroups($PHP_SELF);	}
else if ($action == 'managegroupsearch'){ managegroupsearch($PHP_SELF);	}
else if ($action == 'addnas')		{
	echo "Done";
	if ($snmp == 'checked') 	{
		$snmp = 'on';
	} else { $snmp = '';}
	
	$str = "('','$nasname', '$shortame', '$ipaddr', '$type', '$ports', '$secret', '$community', '$snmp')";

	$sth		= mysql_query("INSERT INTO nas VALUES $str");
}






else if ($action == 'newnas')		{ newnas($PHP_SELF,$body);	}
else if ($action == 'editnas')		{

	$CHECKED	= '';
	$sth		= mysql_query("SELECT * FROM nas WHERE id = '$nasid'");
	$nas		= mysql_fetch_row($sth);

	if ($nas[8] == 'on')
	{
		$CHECKED = 'CHECKED';
	}

	editnas($PHP_SELF,$body,$nas,$CHECKED, $nasid);
}
else if ($action == 'managenas') {

	$str		= '';
	$sth		= mysql_query("SELECT * FROM nas");

	while ($nas	= mysql_fetch_row($sth))
        {
		$str   .=  "<tr align=center><td><a href=\"javascript:editnas($nas[0])\">$nas[1]</a></td><td>$nas[2]</td><td>$nas[3]</td><td>$nas[4]</td><td>$nas[5]</td><td>$nas[6]</td><td>$nas[7]</td><td>$nas[8]</td><td><input type=checkbox name=nasid value=\"$nas[0]\"></tr>\n";
	}

	managenas($PHP_SELF,$body,$str);
}
else if (isset($findgroup)) {

	$list		= $seen = array();
        $str		= '';
	$sth		= mysql_query("SELECT DISTINCT GroupName FROM radgroupcheck WHERE GroupName LIKE '$group%'");

	while ($grp	= mysql_fetch_row($sth)) 
	{
		$list[] = $grp[0];
	}

	$sth		= mysql_query("SELECT DISTINCT GroupName FROM radgroupreply WHERE GroupName LIKE '$group%'");

	while ($grp	= mysql_fetch_row($sth))
        {
		$list[] = $grp[0];
	}

	while(list($k,$group)=each($list))
	{
# help! --markc		if ($seen[$group]) { $seen[$group]++; next; }
		$sth	= mysql_query("SELECT id FROM radgroupcheck WHERE GroupName = '$group'");
		list($groupid) = mysql_fetch_row($sth);
		$from	= 'check';

		if (!$groupid)
        	{
			$sth = mysql_query("SELECT id FROM radgroupreply WHERE GroupName = '$group'");
			list($groupid) = mysql_fetch_row($sth);
			$from = 'reply';
		}
		$str .= "<tr align=center><td><a href=\"$PHP_SELF?groupid=$groupid&from=$from&action=editgroup\" target=\"rightmainframe\">$group</a></td></tr>\n";
	}
	findgroup($body,$str);
}
else if ($action == 'edituser')		{ edituser($PHP_SELF,$userid);		}
else if ($action == 'editusertop')	{ editusertop($body);			}
else if ($action == 'userargvlist')	{

	$str1 = $str2 = $str3 = '';

	$userid_query	= mysql_query("SELECT UserName FROM radcheck WHERE id = '$userid'");
	list($name)	= mysql_fetch_row($userid_query);
	$check_query	= mysql_query("SELECT * FROM radcheck WHERE UserName = '$name'");
	$groupcheck_query = mysql_query("SELECT radgroupcheck.* FROM radgroupcheck, usergroup where usergroup.GroupName = radgroupcheck.GroupName and usergroup.UserName = '$name'");
	$reply_query	= mysql_query("SELECT * FROM radreply WHERE UserName = '$name'");
	$groupreply_query = mysql_query("SELECT radgroupreply.* FROM radgroupreply, usergroup where usergroup.GroupName = radgroupreply.GroupName and usergroup.UserName = '$name'");
	$groups_query	= mysql_query("SELECT * FROM usergroup WHERE UserName = '$name'");

	while ($checks = mysql_fetch_row($check_query))
	{
		$str1 .= "<tr><td><a href=\"$PHP_SELF?action=editusercheck&userid=$checks[0]\" target=\"editusertop\">$checks[2]</a></td><td>$checks[3]</td><td align=center><input type=checkbox name=argvid[] value=\"$checks[0]\"></td><td align=center>--</td></tr>\n";
	}

	while ($checks = mysql_fetch_row($groupcheck_query))
        {
		$str1 .= "<tr><td><font color=green>$checks[2]</font></td><td><font color=green>$checks[3]</font></td><td align=center><font color=green>--</font></td><td align=center><a href=\"$PHP_SELF?action=editgroup&groupid=$checks[0]\&from=check\" target=\"rightmainframe\">$checks[1]</a></td></tr>\n";
	}

	while ($reply = mysql_fetch_row($reply_query))
        {
		$str2 .= "<tr><td><a href=\"$PHP_SELF?action=edituserreply&userid=$userid&replyid=$reply[0]\" target=\"editusertop\">$reply[2]</a></td><td>$reply[3]</td><td align=center><input type=checkbox name=argvid[] value=\"$reply[0]\"></td><td align=center>--</td></tr>\n";
	}

	while ($reply = mysql_fetch_row($groupreply_query))
        {
		$str2 .= "<tr><td><font color=green>$reply[2]</font></td><td><font color=green>$reply[3]</font></td><td align=center><font color=green>--</font></td><td align=center><a href=\"$PHP_SELF?action=editgroup&groupid=$reply[0]&from=reply\" target=\"rightmainframe\">$reply[1]</a></td></tr>\n";
	}

	while ($groups = mysql_fetch_row($groups_query))
        {
		$str3 .= "<tr><td><a href=\"$PHP_SELF?action=editusergroup&groupid=$groups[0]\" target=\"rightmaingrame\">$groups[2]</a></td>\n";
                $str3 .= "<td align=center><input type=checkbox name=\"usergroupid[]\" value=\"$groups[0]\"></tr>\n";
	}

	userargvlist($PHP_SELF,$body,$userid,$name,$str1,$str2,$str3);
}
else if ($action == 'addtogroup')		{

	$list = $name = $seen = array();
	$str		= '';
	$sth		= mysql_query("SELECT UserName FROM radcheck WHERE id = '$userid'");
	list($name)	= mysql_fetch_row($sth);
	$sth		= mysql_query("SELECT DISTINCT GroupName FROM radgroupcheck radgroupreply");

	while (list($group) = mysql_fetch_row($sth))
	{
		$str .= "<option value=$group>$group\n";
	}

	addtogroup($PHP_SELF,$body,$name,$userid,$str);
}
else if (isset($addusercheck))		{

	$str1 = $str2	= '';

	if (isset($doaddusercheck))
	{
		$body	= "<body OnLoad=\"makechanges('$userid');\">\n";
	}

	if (isset($attribute))
	{
		$str1	= "<option selected>$attribute\n";
	} else {
		$str1	= "<option selected>Choose Check Item Attribute\n";
	}

	$sth		= mysql_query("SELECT Attribute, Vendor FROM dictionary WHERE type = 'ATTRIBUTE' ORDER BY Attribute");

	while (list($attrib, $vendor) = mysql_fetch_row($sth))
	{
		if ($attrib != $attributenext)
		{
			$str1 .= "<option value=\"$attrib\">$attrib";
			if ($vendor) { $str1 .=  " (VSA $vendor)"; }
			$str1 .=  "\n";
		}
	}

	if ($attribute == $oldattrib)
	{
		$val	= $value;
	}

	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
	{
		$vals[] = $currval;
	}

	if ($vals)
        {
		$str2	= "<td><select name=\"value\">\n";
		if ($val) $str2 .= "<option selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str2 .= "<option>$printval\n";
			}
		}
		$str2  .=  "</select></td>\n";
	} else {
		$str2  .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}

	addusercheck($PHP_SELF,$body,$userid,$username,$attribute,$str1,$str2);
}
else if (isset($adduserreply)) {

	$str1 = $str2	= '';

	if (isset($doaddusercheck))
	{
		$body	= "<body OnLoad=\"makechanges('$userid');\">\n";
	}

	if (isset($attribute))
	{
		$str1	= "<option selected>$attribute\n";
	} else {
		$str1	= "<option selected>Choose Check Item Attribute\n";
	}

	$sth		= mysql_query("SELECT Attribute, Vendor FROM dictionary WHERE type = 'ATTRIBUTE' ORDER BY Attribute");

	while (list($attrib, $vendor) = mysql_fetch_row($sth))
	{
		if ($attrib != $attributenext)
		{
			$str1 .= "<option value=\"$attrib\">$attrib";
			if ($vendor) { $str1 .=  " (VSA $vendor)"; }
			$str1 .=  "\n";
		}
	}

	if ($attribute == $oldattrib)
	{
		$val	= $value;
	}

	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
	{
		$vals[] = $currval;
	}

	if ($vals)
        {
		$str2	= "<td><select name=\"value\">\n";
		if ($val) $str2 .= "<option selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str2 .= "<option>$printval\n";
			}
		}
		$str2  .=  "</select></td>\n";
	} else {
		$str2  .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}

	adduserreply($PHP_SELF,$body,$userid,$username,$attribute,$str1,$str2);
}
else if (!strcmp($action,'editusercheck')) {

	$str		= '';
	$sth		= mysql_query("SELECT * FROM radcheck WHERE id = '$userid'");
	$checks		= mysql_fetch_row($sth);
	$attribute	= $checks[2];
	$value		= $checks[3];

	if (isset($doeditusercheck))
	{
		$body	= "<body bgcolor=\"#ffffff\" OnLoad=\"makechanges('$userid');\">\n";
	} 

	$val		= $value;
	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
        {
		$vals[] = $currval;
	}

	if ($vals)
        {
		$str	= "<td><select name=\"value\">\n";
		if ($val) $str .= "<option selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str .=  "<option value=$printval>$printval\n";
			}
		}
		$str   .= "</select></td>\n";
	} else {
		$str   .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}

	editusercheck($PHP_SELF,$body,$userid,$attribute,$str);
}
else if (!strcmp($action,'edituserreply')) {

	$sth		= mysql_query("SELECT * FROM radreply WHERE id = '$replyid'");
	$reply		= mysql_fetch_row($sth);
	$attribute	= $reply[2];
	$value		= $reply[3];
	$val		= $value;
	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
	{
		$vals[] = $currval;
	}

	if ($vals)
        {
		$str	= "<td><select name=\"value\">\n";
		if ($val) $str .= "<option selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str .= "<option>$printval\n";
			}
		}
		$str   .= "</select></td>\n";
	} else {
		$str   .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}
	if (isset($doedituserreply))
        {
		$body	= "<body bgcolor=\"#ffffff\" OnLoad=\"makechanges('$userid');\">\n";
	}

	edituserreply($PHP_SELF,$body,$str,$userid,$replyid,$attribute);
}
else if ($action == 'editgroup')	{ editgroup($PHP_SELF,$groupid, $from); }




else if ($action == 'editgrouptop')	{ editgrouptop($body);		}
else if ($action == 'groupargvlist')	{

	$str1 = $str2	= '';
	if (!isset($groupname)) $groupname = '';

	if (!$groupname)
	{
#		$groupid = '1';
		$from = "check";
		$sth	= mysql_query("SELECT GroupName FROM radgroup$from WHERE id = '$groupid'");
#		echo "$groupid\n";
#		echo "$from\n"; 
		list($name) = mysql_fetch_row($sth);
	} else {
		$name	= $groupname;
	}

	$sth1		= mysql_query("SELECT * FROM radgroupcheck WHERE GroupName = '$name'");
	$sth2		= mysql_query("SELECT * FROM radgroupreply WHERE GroupName = '$name'");

	while ($checks	= mysql_fetch_row($sth1))
	{
		$str1  .= "<tr><td><a href=\"$PHP_SELF?action=editgroupcheck&id=$checks[0]&groupid=$groupid\" target=\"editgrouptop\">$checks[2]</a></td>\n";
		$str1  .= "<td>$checks[3]</td><td align=center><input type=checkbox name=argvid[] value=\"$checks[0]\"></td></tr>\n";
	}
	while ($reply	= mysql_fetch_row($sth2))
	{
		$str2  .= "<tr><td><a href=\"$PHP_SELF?action=editgroupreply&id=$reply[0]&groupid=$groupid\" target=\"editgrouptop\">$reply[2]</a></td>\n";
		$str2  .= "<td>$reply[3]</td><td align=center><input type=checkbox name=argvid[] value=\"$reply[0]\"></td></tr>\n";
	}
	groupargvlist($PHP_SELF,$body,$groupid,$name,$str1,$str2);
}
else if (isset($addgroupcheck)) {

	if (isset($doaddgroupcheck))
	{
		$body	= "<body bgcolor=\"#ffffff\" OnLoad=\"makechanges('$groupid');\">\n";
	}

	if (isset($attribute))
	{
		$str1	= "<option selected>$attribute\n";
	} else {
		$str1	= "<option selected>Choose Check Item Attribute\n";
	}

	$sth		= mysql_query("SELECT Attribute, Vendor FROM dictionary WHERE type = 'ATTRIBUTE' ORDER BY Attribute");

	while (list($attrib, $vendor) = mysql_fetch_row($sth))
	{
		if ($attrib != $attribute)
		{
			$str1 .= "<option value=\"$attrib\">$attrib";
			if ($vendor) $str1 .= " (VSA $vendor)";
			$str1 .= "\n";
		}
	}

	if ((isset($attribute) && isset($oldattrib)) && $attribute == $oldattrib)
	{
		$val	= $value;
	}

	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
	{
		$vals[] = $currval;
	}

	if ($vals)
        {
		$str2	= "<td><select name=\"value\">\n";
		if ($val) $str2 .= "<option selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str2 .= "<option>$printval\n";
			}
		}
		$str2  .=  "</select></td>\n";
	} else {
		$str2  .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}

	addgroupcheck($PHP_SELF,$body,$str1,$str2,$groupid,$groupname);
}
else if (isset($addgroupreply)) {

	$str1 = $str2	= '';

	if (isset($doaddgroupreply))
	{
		$body	= "<body OnLoad=\"makechanges('$groupid');\">\n";
	}

	if (isset($attribute))
        {
		$str1  .= "<option selected>$attribute\n";
	} else {
		$str1  .= "<option selected>Choose Reply Item Attribute\n";
	}

	$sth = mysql_query("SELECT Attribute, Vendor FROM dictionary WHERE type = 'ATTRIBUTE' ORDER BY Attribute");

	while (list($attrib, $vendor) = mysql_fetch_row($sth))
	{
#		if (strcmp($attrib,$attribute))
#		{
			$str1 .= "<option value=\"$attrib\">$attrib";
			if ($vendor) $str1 .= " (VSA $vendor)";
			$str1 .= "\n";
#		}
	}

	if ($attribute == $oldattrib)
        {
		$val	= $value;
	}

	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
	{
		$vals[]	= $currval;
	}

	if ($vals)
	{
		$str2   .= "<td><select name=\"value\">\n";
		if ($val) $str .= "<option value=$val selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str2 .= "<option>$printval\n";
			}
		}
		$str2   .= "</select></td>\n";
	} else {
		$str2  .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}

	addgroupreply($PHP_SELF,$body,$groupid,$groupname,$attribute,$str1,$str2);
}
else if (!strcmp($action,'editgroupcheck')) {

	$str1 = $str2	= '';
	$sth		= mysql_query("SELECT * FROM radgroupcheck WHERE id = '$id'");
	$checks		= mysql_fetch_row($sth);
	$attribute	= $checks[2];
	$value		= $checks[3];

	if (isset($doeditgroupcheck))
	{
		$body	= "<body OnLoad=\"makechanges('$groupid');\">\n";
	}

	$val		= $value;
	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
	{
		$vals[] = $currval;
	}

	if ($vals)
	{
		$str	= "<td><select name=\"value\">\n";
		if ($val) $str .= "<option selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str .= "<option value=$printval>$printval\n";
			}
		}
		$str   .= "</select></td>\n";
	} else {
		$str   .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}

	editgroupcheck($PHP_SELF,$body,$groupid,$attribute,$str,$id);
}
else if (!strcmp($action,'editgroupreply')) {

	$str		= '';
	$sth		= mysql_query("SELECT * FROM radgroupreply WHERE id = '$id'");
	$reply		= mysql_fetch_row($sth);
	$attribute	= $reply[2];
	$value		= $reply[3];

	if (isset($doeditgroupreply))
        {
		$body	= "<body bgcolor=\"#ffffff\" OnLoad=\"makechanges('$groupid');\">\n";
	}

	$val		= $value;
	$sth		= mysql_query("SELECT Value FROM dictionary WHERE Type = 'VALUE' AND Attribute = '$attribute'");
	$vals		= array();

	while (list($currval) = mysql_fetch_row($sth))
	{
		$vals[]	= $currval;
	}

	if ($vals)
	{
		$str   .= "<td><select name=\"value\">\n";
		if ($val) $str .= "<option value=$val selected>$val\n";

		while(list($k,$printval)=each($vals))
		{
			if ($printval != $val)
			{
				$str .= "<option>$printval\n";
			}
		}
		$str   .= "</select></td>\n";
	} else {
		$str   .= "<td><input type=textbox name=\"value\" value=\"$val\" size=20></td>\n";
	}

	editgroupreply($PHP_SELF,$body,$groupid,$attribute,$str,$id);
}
else if ($action == 'adduser')		{ adduser($PHP_SELF,$body);	}
else if ($action == 'addgroup')		{ addgroup($PHP_SELF,$body);	}
else if ($action == 'realaddgroup')	{ realaddgroup($PHP_SELF,$body);}
else if ($action == 'loginstatus' || isset($loginstatusreport)) {

	$str		= '';
	$termcauses = array("","User-Request","Lost-Carrier","Lost-Service","Idle-Timeout","Session-Timeout","Admin-Reset","Admin-Reboot","Port-Error","NAS-Error","NAS-Request","NAS-Reboot","Port-Unneeded","Port-Preempted","Port-Suspended","Service-Unavailable",
"Callback","User-Error","Host-Request");
	if (!isset($loginstatusreport))	$fromtime	= getdatetime();
	if (!isset($loginstatusreport))	$totime		= getdatetime();
	if (!isset($username))		$username	= '';
	if (!isset($nasip))		$nasip		= '';
	if (!isset($fromtime))		$fromtime	= '';
	if (!isset($nasport))		$nasport	= '';
	if (!isset($totime))		$totime		= '';
	if (!isset($nasporttype))	$nasporttype	= '';
	if (!isset($framedipaddress))	$framedipaddress= '';
	if (!isset($terminatecause))	$terminatecause	= '';

	while(list($k,$cause)=each($termcauses))
	{
		if ($cause != $terminatecause)
		{
			$str .= "<option>$cause\n";
		}
	}
	loginstatus($PHP_SELF,$body,$str,$username,$nasip,$fromtime,$nasport,$totime,$nasporttype,$framedipaddress,$terminatecause);
}
else if ($action == 'getrecord')		{

	$recorddata	= array();
	$sth		= mysql_query("select * from radacct where RadacctID = '$id'");
	$recorddata	= mysql_fetch_row($sth);

	getrecord($body,$recorddata);
}
else if ($action == 'viewlog')			{ viewlog($PHP_SELF,$body);	} 
else if ($action == 'detailed')			{

	if (!isset($username)) $username = '';

        detailed($PHP_SELF,$body,$username,$now);
}
else if (!strcmp($action,'abuse') || isset($abusereport)) {

	$printlimit	= "240";
	if (isset($hours)) $printlimit = $hours;

	abuse($PHP_SELF,$body,$printlimit);
}

#---- fourth executable code switch ----------------------------------------------

if (isset($loginstatusreport))			{

	$str = $sql	= '';
	$timeused	= $secused = $timesth = $stoptimedisplay = 0;
       
	if (!$fromtime && !$totime)
        {
		$sql	= "SELECT UserName, FramedIPAddress, AcctStartTime, AcctStopTime, AcctSessionTime, RadacctID, concat(nasipaddress, '/S', nasportid) FROM radacct WHERE AcctStopTime = 0";
	} else {
		$sql	= "SELECT UserName, FramedIPAddress, AcctStartTime, AcctStopTime, AcctSessionTime, RadacctID, concat(nasipaddress, '/S', nasportid) FROM radacct WHERE (AcctStopTime >= '$fromtime' AND AcctStartTime <= '$totime')";
	}

	if ($username)		{ $sql .= " AND UserName	= '$username'"; }
	if ($nasip)		{ $sql .= " AND NASIPAddress	= '$nasip'"; }
	if ($nasport)		{ $sql .= " AND NASPortId	= '$nasport'"; }
	if ($nasporttype)	{ $sql .= " AND NASPortType	= '$nasporttype'"; }
	if ($framedipaddress)	{ $sql .= " AND FramedIPAddress = '$framedipaddress'"; }
	if ($terminatecause)	{ $sql .= " AND AcctTerminateCause = '$terminatecause'"; }
  
	$sql	       .= ' ORDER BY UserName';
	$sth		= mysql_query($sql);

	while ($sessiondata = mysql_fetch_row($sth))
        {
		$i++;
		if ($sessiondata[4] == 0)
		{
			$timesth = mysql_query("SELECT UNIX_TIMESTAMP(NOW()) - UNIX_TIMESTAMP('$sessiondata[2]')");
			list($secused) = mysql_fetch_row($timesth);
			$timeused = formatseconds($secused);
			$total += $secused;
		} else {
			$timeused = formatseconds($sessiondata[4]);
			$total += $sessiondata[4];
		}

		$stoptimedisplay = $sessiondata[3];

		if ($sessiondata[3] == '0000-00-00 00:00:00')
                {
                	$stoptimedisplay = "Currently Logged On";
		}

		$str  .= "
      <tr>
        <td><a href=\"$PHP_SELF?action=getrecord&id=$sessiondata[5]\"> $sessiondata[0] </a></td>
        <td> $sessiondata[1] </td>
        <td> $sessiondata[6] </td>
        <td> $sessiondata[2] </td>
        <td> $stoptimedisplay </td>
        <td> $timeused </td></tr>\n";
	}

	$realtotal	= formatseconds($total);

	loginstatusreport($i,$realtotal,$str);
}
else if (isset($detailedreport)) { 

	$str		= '';
	if (!$from)	$from = 'Any';
	if (!$to)	$to = 'Any';
  
	if ($from && $to)
        {
		$sql	= "SELECT UserName, RadacctID, AcctStartTime, AcctStopTime, FramedIPAddress, AcctSessionTime FROM radacct WHERE AcctStartTime >= '$from' AND AcctStopTime <= '$to' AND AcctStopTime != 0 AND UserName = '$username'";
	} else if ($from) {
		$sql	= "SELECT UserName, RadacctID, AcctStartTime, AcctStopTime, FramedIPAddress, AcctSessionTime FROM radacct WHERE AcctStartTime >= '$from' AND UserName = '$username'";
	} else if ($to) {
		$sql	= "SELECT UserName, RadacctID, AcctStartTime, AcctStopTime, FramedIPAddress, AcctSessionTime FROM radacct WHERE AcctStopTime <= '$to' AND AcctStopTime != 0 AND UserName = '$username'";
	} else {
		$sql	= "SELECT UserName, RadacctID, AcctStartTime, AcctStopTime, FramedIPAddress, AcctSessionTime FROM radacct WHERE UserName = '$username'";
	}

	$sumsth		= mysql_query($sql);
	$total		= 0;
	$printused	= 0;

	while ($sessiondata = mysql_fetch_row($sumsth))
        {
		$printused = formatseconds($sessiondata[5]);
		$str   .= "<tr align=center><td><a href=\"$PHP_SELF?action=getrecord&id=$sessiondata[1]\">$sessiondata[0]</a></td>\n";
                $str   .= "<td>$sessiondata[4]</td><td>$sessiondata[2]</td><td>$sessiondata[3]</td><td>$printused</td></tr>\n";
		$total += $sessiondata[5];
	}

	$printtotal	= formatseconds($total);

	detailedreport($body,$username,$from,$to,$printtotal,$str);
}
else if (isset($utilgraph)) {

	$str1 = $str2	= '';
        $totalused = $totalports = 0;

	if ($time)
	{
        	$str1	= "<br>Graph of nas usage at $time<br><br>\n";
	} else {
		$str1	= "<br>Graph of current nas utilization<br><br>\n";
	}

	$imagewidth	= 0;

	$sth1		= mysql_query("SELECT id, ipaddr, shortname, ports FROM nas WHERE ports > 0 ORDER BY id");

	while ($pdata = mysql_fetch_row($sth1))
        {
		if ($time)
                {
# modified by bcp1 19991212 changed the original statement to the style that i
# user for quoting varibles.  it worked first time.
			$sth = mysql_query("SELECT count(*) FROM radacct WHERE ((AcctStartTime <= '$time' AND AcctStopTime >= '$time') OR (AcctStartTime <= '$time' AND AcctStopTime = 0)) AND NASIPAddress = '$pdata[1]'");
		} else {
			$sth = mysql_query("SELECT count(*) FROM radacct WHERE AcctStopTime = 0 AND NASIPAddress = '$pdata[1]' AND UserName != '' AND UserName != 'admin'");
		}
		$ports		= mysql_fetch_row($sth);
                $portsused	= $ports[0];
		$imagewidth	= $portsused * 6;
		$percent	= (int) $portsused/$pdata[3] * 100;
		$diff		= $pdata[3] - $portsused;
		$displaydiff	= $diff * 6;
# modified by bcp1 19991212 to fix output.  added below.
		$percentformat	= number_format($percent,2);
		$str2 .= "<tr><td>$pdata[2]</td><td>\n";
                $str2 .= "<img src=\"images/l.gif\" height=20>";
                $str2 .= "<img src=\"images/lc.gif\" height=20 width=$imagewidth>";
                $str2 .= "<img src=\"images/rc.gif\" height=20>";
                $str2 .= "<img src=\"images/r.gif\" height=20 width=$displaydiff>";
                $str2 .= "<img src=\"images/rr.gif\" height=20> $portsused/$pdata[3] ($percentformat%)</td></tr>\n";

		$totalports += $pdata[3];
		$totalused += $portsused;
	} 

	$totalpercent	= $totalused/$totalports * 100;
  	list($percent, $junk) = split("\.", $totalpercent);

	utilgraph($body,$percent,$totalused,$totalports,$str1,$str2);
}
else if (isset($summaryreport)) {

	$i		= 0;
	$totalsum	= 0;
        $str		= '';
	$orderby	= 'UserName';
	$sql		= 'SELECT UserName, SUM(AcctSessionTime) / 3600 as s FROM radacct ';

	if ($from && $to)
        {
		$sql   .= "WHERE AcctStartTime >= '$from' and AcctStopTime <= '$to' and AcctStopTime != 0 GROUP BY UserName HAVING s != 0 ORDER BY $orderby $direction";
	} else if ($from) {
		$sql   .= "WHERE AcctStartTime >= '$from' GROUP BY UserName HAVING s != 0 ORDER BY $orderby $direction";
	} else if ($to) {
		$sql   .= "WHERE AcctStopTime <= '$to' and AcctStopTime != 0 GROUP BY UserName HAVING s != 0 ORDER BY $orderby $direction";
	} else {
		$sql   .= "GROUP BY UserName HAVING s != 0 ORDER BY $orderby $direction";
	}

	$sumsth		= mysql_query($sql);

	while (list($user, $sum) = mysql_fetch_row($sumsth))
        {
		$i++;
		$totalsum += $sum;
		$str   .= "<tr><td><a href=\"$PHP_SELF?action=detailed&username=$user\">$user</a></td><td align=\"right\">$sum</td></tr>\n";
	}

	summaryreport($i,$totalsum,$str);

} else if (isset($abusereport)) {  error_log("4 abusereport");

# help! --markc

	$ABUSER		= array(array());
	$SUSPECT	= array(array());
	$from		= $year.'-'.$month.'-01 00:00:00';
	$newmonth	= $month + 1;
	$to		= $year.'-'.$newmonth.'-01 00:00:00';
	$limit		= $hours;
	$sth		= mysql_query("SELECT UserName, SUM(AcctSessionTime) AS s FROM radacct WHERE AcctStartTime >= '$from' AND AcctStopTime <= '$to' GROUP BY UserName ORDER BY s DESC");

	while ($data = mysql_fetch_row($sth))
	{
error_log("$data[0],$data[1]");
		$hours		= $data[1] / 3600;
		$avgdaily	= $hours / $DAYSPERMON;
		#$avgdaily	= $hours / getdayofmon();
		$dailylimit	= $limit / $DAYSPERMON;

		if ($hours > $limit)
                {
			$ABUSER["$data[0]"] = $hours;
		}

		#if ($ABUSER["$data[1]"] != 0) 
                #{
		else if ($avgdaily > $dailylimit)
                	{
				#$SUSPECT["$data[0]"] = $hours;
				$SUSPECT["$data[0]"] = array($avgdaily, $hours);
			}
                #}
	}

	echo "Abusers over $limit hours<br><br>\n";
	echo "<table border=1>\n";
	echo "<tr><th>UserName</th><th>Hours Used</th></tr>\n";

# modified by bcp1 19991212
# changed below from $user to $usera
	while($data1=each($ABUSER))
        {
error_log("usera=$usera,hours=".$ABUSER[$data1[0]]);
		list($printhours, $junk) = split("\.", $k);
		$kformat = number_format($k,2);
		echo "<tr align=center><td>$usera</td><td>$kformat</td></tr>\n";
		#echo "<tr align=center><td>$user</td><td>$printhours</td></tr>\n";
	}
	echo "</table>\n";

	echo "<br><br>Users projected to go over $limit hours<br><br>\n";
	echo "<table border=1>\n";
	echo "<tr><th>UserName</th><th>Average Hours<br>Per Day</th><th>Projected Use<br>This Month</th><th>Hours Used<br>So Far</th></tr>\n";

# modified by bcp1 19991212
# trying to emulate above, but that doesn't seem to be the 
# problem.  it appears that $SUSPECT isn't getting populated.
# this is where i left off...

	while(list($userb,$kb)=each($SUSPECT))
        {
error_log("userb=$userb,hours=$kb");
		$suspects = $SUSPECT[$userb];
		echo "<tr align=center><td>$userb</td><td>$suspects[0]</td><td>$suspects[1]</td><td>$suspects[2]</td></tr>\n";
	}
	echo "</table>\n";
}
else if ($action == 'login')		{ printheader(); printlogin();	}
else { error_log("End of the world"); }

?>
